
#version 150

// vsPosition was bound to attribute index 0 and vsColor was bound to attribute index 1
in vec2 vsPosition;
in vec4 vsColor;
in vec2 vsTextureUV;

// We output the ex_Color variable to the next shader in the chain
out vec4 fsColor;
out vec2 fsTextureUV;

uniform mat4 uObjectToProjection;

void main(void)
{
	// Since we are using flat lines, our input only had two points: x and y.
	// Set the Z coordinate to 0 and W coordinate to 1

	//The flooring of the position avoided jittery movement for sprites/text.
	vec2 floorPosition = floor(vsPosition);
	gl_Position = vec4(floorPosition, 0.0, 1.0) * uObjectToProjection;

	fsColor = vsColor;
	fsColor.rgb *= fsColor.a;
	fsTextureUV = vsTextureUV;
}
