#version 150
#extension GL_AMD_vertex_shader_viewport_index : enable

// vsPosition was bound to attribute index 0 and vsColor was bound to attribute index 1
in vec3 vsPosition;
in vec4 vsColor;
in vec2 vsTextureUV;

// Our outputs the next shader (fragment) in the chain
out vec4 fsColor;
out vec2 fsTextureUV;

uniform mat4 uObjectToWorld;
uniform int uTotalViewportCount;
uniform int uCurrentViewportIndex;
uniform mat4 uShadowMatrices[4]; //WorldToShadow? WorldToLightView...

void main(void)
{
#ifdef GL_AMD_vertex_shader_viewport_index
	if (uTotalViewportCount > 1)
	{
		gl_ViewportIndex = gl_InstanceID % uTotalViewportCount;
		gl_Position = vec4(vsPosition, 1.0) * uObjectToWorld * uShadowMatrices[gl_ViewportIndex];
	}
	else
	{
		gl_Position = vec4(vsPosition, 1.0) * uObjectToWorld * uShadowMatrices[uCurrentViewportIndex];
	}
#else
	gl_Position = vec4(vsPosition, 1.0) * uObjectToWorld * uShadowMatrices[uCurrentViewportIndex];
#endif

	fsColor = vsColor;
	fsTextureUV = vsTextureUV;
}
